Index: NEMO/branches/2019/dev_r10721_KERNEL-02_Storkey_Coward_IMMERSE_first_steps/src/OCE/FLO/flodom.F90
===================================================================
--- NEMO/branches/2019/dev_r10721_KERNEL-02_Storkey_Coward_IMMERSE_first_steps/src/OCE/FLO/flodom.F90	(revision 10740)
+++ NEMO/branches/2019/dev_r10721_KERNEL-02_Storkey_Coward_IMMERSE_first_steps/src/OCE/FLO/flodom.F90	(revision 10970)
@@ -44,5 +44,5 @@
 CONTAINS
 
-   SUBROUTINE flo_dom
+   SUBROUTINE flo_dom( Kmm )
       !! ---------------------------------------------------------------------
       !!                  ***  ROUTINE flo_dom  ***
@@ -53,4 +53,6 @@
       !!               the longitude (degree) and the depth (m).
       !!----------------------------------------------------------------------      
+      INTEGER, INTENT(in) ::  Kmm    ! ocean time level index
+      !
       INTEGER            ::   jfl    ! dummy loop  
       INTEGER            ::   inum   ! logical unit for file read
@@ -94,5 +96,5 @@
                 CALL flo_add_new_ariane_floats(jpnrstflo+1,jpnfl) 
             ELSE                 !Add new floats with long/lat convention
-                CALL flo_add_new_floats(jpnrstflo+1,jpnfl)
+                CALL flo_add_new_floats(Kmm,jpnrstflo+1,jpnfl)
             ENDIF
          ENDIF
@@ -106,5 +108,5 @@
             CALL flo_add_new_ariane_floats(1,jpnfl)
          ELSE                      !Add new floats with long/lat convention
-            CALL flo_add_new_floats(1,jpnfl)
+            CALL flo_add_new_floats(Kmm,1,jpnfl)
          ENDIF
 
@@ -113,5 +115,5 @@
    END SUBROUTINE flo_dom
 
-   SUBROUTINE flo_add_new_floats(kfl_start, kfl_end)
+   SUBROUTINE flo_add_new_floats(Kmm, kfl_start, kfl_end)
       !! -------------------------------------------------------------
       !!                 ***  SUBROUTINE add_new_arianefloats  ***
@@ -128,4 +130,5 @@
       !! ** Method  : 
       !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) :: Kmm
       INTEGER, INTENT(in) :: kfl_start, kfl_end
       !!
@@ -174,5 +177,5 @@
                   ihtest(jfl) = ihtest(jfl)+1
                   DO jk = 1, jpk-1
-                     IF( (gdepw_n(ji,jj,jk) <= flzz(jfl)) .AND. (gdepw_n(ji,jj,jk+1) > flzz(jfl)) ) THEN
+                     IF( (gdepw(ji,jj,jk,Kmm) <= flzz(jfl)) .AND. (gdepw(ji,jj,jk+1,Kmm) > flzz(jfl)) ) THEN
                         ikmfl(jfl) = jk
                         ivtest(jfl) = ivtest(jfl) + 1
@@ -236,10 +239,10 @@
             zgifl(jfl)= (iimfl(jfl)-0.5) + zdxab/e1u(iimfl(jfl)-1,ijmfl(jfl)) + (mig(1)-1)
             zgjfl(jfl)= (ijmfl(jfl)-0.5) + zdyad/e2v(iimfl(jfl),ijmfl(jfl)-1) + (mjg(1)-1)
-            zgkfl(jfl) = (( gdepw_n(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)+1) - flzz(jfl) )* ikmfl(jfl))   &
-               &                 / (  gdepw_n(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)+1)                              &
-               &                    - gdepw_n(iimfl(jfl),ijmfl(jfl),ikmfl(jfl) ) )                             &
-               &                 + (( flzz(jfl)-gdepw_n(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)) ) *(ikmfl(jfl)+1))   &
-               &                 / (  gdepw_n(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)+1)                              &
-               &                    - gdepw_n(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)) )
+            zgkfl(jfl) = (( gdepw(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)+1,Kmm) - flzz(jfl) )* ikmfl(jfl))   &
+               &                 / (  gdepw(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)+1,Kmm)                              &
+               &                    - gdepw(iimfl(jfl),ijmfl(jfl),ikmfl(jfl) ,Kmm) )                             &
+               &                 + (( flzz(jfl)-gdepw(iimfl(jfl),ijmfl(jfl),ikmfl(jfl),Kmm) ) *(ikmfl(jfl)+1))   &
+               &                 / (  gdepw(iimfl(jfl),ijmfl(jfl),ikmfl(jfl)+1,Kmm)                              &
+               &                    - gdepw(iimfl(jfl),ijmfl(jfl),ikmfl(jfl),Kmm) )
          ELSE
             zgifl(jfl) = 0.e0